/*
   This program shows a few simple ways that C programs can
   produce numerical results that are surprising and "incorrect".

   By the end of Chapter 2 we can explain in detail exactly what
   is happening with each of these example.
*/
#include <stdio.h>
#include <stdlib.h>

int main (int argc, char* argv[])
{
   // The product of positive numbers can be a negative number.
   int x = 200 * 300 * 400 * 500;
   printf("x = %d\n", x);

   // The addition operation is not associative.
   double y = (3.14 + 1e20) - 1e20;
   double z =  3.14 +(1e20  - 1e20);
   printf("y = %f\n", y);
   printf("z = %f\n", z);

   // There can be conversion errors.
   double u = 4.77;
   int v = (int)(100*u);
   printf("u = %f\n", u);
   printf("v = %d\n", v);

   unsigned w = 2147483648; /* 2 to the 31st */
   printf("w = %d\n", w);

   return 0;
}
