/*
   This program emphasizes that the binary bits in a
   computer's memory do not, by themselves, have any
   meaning. One has to choose an interpretation for the
   bits. In this program, we look at the same four bytes
   of memory and give those four bytes three different
   interpretation, as an integer, as a float, and as a
   string. We switch between the three interpretations
   by casting the data type of a pointer.

   Try changing the characters in the string and see how
   the integer and the float values change.
*/
#include <stdio.h>

int main( )
{
   char s[] = {'h', 'o', 'p', 'e', '\0'};  /*  0x 68 6f 70 65  */

   printf( "         s = %s\n", s );
   printf( "  *(int*)s = %d\n", *(int*)s );
   printf( "*(float*)s = %f\n", *(float*)s );  

   // Why doesn't the output from the following printf
   // agree with the third printf above?
   printf("             %f\n", 1701867368);
   printf("             %f\n", 0x686f7065);

   return 0;
}
